&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Include 
/*--------------------------------------------------------------------------
    File        : s-systray.i
    Purpose     : enables a window to run minimized in the systray.

    Syntax      :

    Description :

    Author(s)   : Rob den Boer
                  modified for winEd4W.w by Jurjen Dijkstra, 3/2/2002
    Created     : 20-1-1999
    Notes       :
  ------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/*--- defines from Winapi32.txt ---*/

&GLOBAL-DEFINE WM_MOUSEFIRST    512
&GLOBAL-DEFINE WM_MOUSEMOVE     512
&GLOBAL-DEFINE WM_LBUTTONDOWN   513
&GLOBAL-DEFINE WM_LBUTTONUP     514
&GLOBAL-DEFINE WM_LBUTTONDBLCLK 515
&GLOBAL-DEFINE WM_RBUTTONDOWN   516
&GLOBAL-DEFINE WM_RBUTTONUP     517
&GLOBAL-DEFINE WM_RBUTTONDBLCLK 518
&GLOBAL-DEFINE WM_MBUTTONDOWN   519
&GLOBAL-DEFINE WM_MBUTTONUP     520
&GLOBAL-DEFINE WM_MBUTTONDBLCLK 521
&GLOBAL-DEFINE WM_MOUSELAST     521


&GLOBAL-DEFINE SHGFI_ICON             256
&GLOBAL-DEFINE SHGFI_SMALLICON          1

&GLOBAL-DEFINE NIM_ADD     0
&GLOBAL-DEFINE NIM_MODIFY  1
&GLOBAL-DEFINE NIM_DELETE  2
&GLOBAL-DEFINE NIF_MESSAGE 1
&GLOBAL-DEFINE NIF_ICON    2
&GLOBAL-DEFINE NIF_TIP     4


/*--- size of the structures ---*/
&GLOBAL-DEFINE SIZEOF_pNotifyIconData   88
&GLOBAL-DEFINE SIZEOF_SHFileInfo       512


DEFINE VARIABLE pNotifyIconData AS MEMPTR NO-UNDO.   /* pointer to icon datastruct */
DEFINE VARIABLE iTrayID      AS INTEGER   NO-UNDO.   /* systray ID needed by win */
DEFINE VARIABLE cIconHandles AS CHARACTER NO-UNDO.   /* commasep. list of ditto handles */
DEFINE VARIABLE iIcons       AS INTEGER   NO-UNDO.   /* total no icons in list */
DEFINE VARIABLE cTooltip     AS CHARACTER NO-UNDO.   /* tooltip */
DEFINE VARIABLE iCurrentIcon AS INTEGER NO-UNDO.     /* current icon no */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fn-get-next-icon Include 
FUNCTION fn-get-next-icon RETURNS INTEGER
  (  )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Include
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: INCLUDE-ONLY
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Include ASSIGN
         HEIGHT             = 10.91
         WIDTH              = 42.4.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Include 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE dlls Include 
PROCEDURE dlls :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

END PROCEDURE.


PROCEDURE SHGetFileInfoA EXTERNAL "shell32.dll":U :
   DEFINE INPUT  PARAMETER pszPath     AS CHAR.
   DEFINE INPUT  PARAMETER dwFileAttr  AS LONG.
   DEFINE INPUT  PARAMETER psfi        AS LONG.  /* memptr */
   DEFINE INPUT  PARAMETER cbfi        AS LONG.  /* size */
   DEFINE INPUT  PARAMETER uFlags      AS LONG. 
   DEFINE RETURN PARAMETER ReturnValue AS LONG.  /* boolean */
END PROCEDURE.


PROCEDURE Shell_NotifyIconA EXTERNAL "shell32.dll":U :
   DEFINE INPUT  PARAMETER dwMessage   AS LONG.
   DEFINE INPUT  PARAMETER pnid        AS LONG. /* memptr */
   DEFINE RETURN PARAMETER ReturnValue AS LONG. /* boolean */
END PROCEDURE.


PROCEDURE SendMessageA EXTERNAL "user32.dll":U :
   DEFINE INPUT PARAMETER win-handle AS LONG.
   DEFINE INPUT PARAMETER win-msg    AS LONG.
   DEFINE INPUT PARAMETER win-param1 AS LONG.
   DEFINE INPUT PARAMETER win-param2 AS LONG.
END.

PROCEDURE GetParent EXTERNAL "user32.dll":U :
  DEFINE INPUT  PARAMETER thishwnd   AS LONG.
  DEFINE RETURN PARAMETER parenthwnd AS LONG.
END PROCEDURE.

FUNCTION fnGetParent RETURNS INTEGER (input hWnd as INTEGER) :
  def var hParent as integer no-undo.
  run GetParent (hWnd, output hParent).
  RETURN (hParent). 
END FUNCTION.    

procedure SetActiveWindow external "user32.dll":U :
  define input parameter hwnd as long.
end procedure.


/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ip-load-icons Include 
PROCEDURE ip-load-icons :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER        pcIconlist    AS CHARACTER NO-UNDO.
  DEFINE INPUT-OUTPUT PARAMETER pcIconHandles AS CHARACTER NO-UNDO.

  DEFINE VARIABLE i AS INTEGER NO-UNDO.
  DEFINE VARIABLE cIconFile AS CHARACTER NO-UNDO.
  DEFINE VARIABLE lpSHFileInfo AS MEMPTR  NO-UNDO.
  DEFINE VARIABLE hIcon        AS INTEGER NO-UNDO.
  DEFINE VARIABLE hTrayIcon    AS INTEGER NO-UNDO.


  /* --- allocate memory to support SHFileInfo structure --- */
  SET-SIZE(lpSHFileInfo) = {&SIZEOF_SHFileInfo}.
  
  /* walk through the iconlist */
  ASSIGN iIcons = NUM-ENTRIES(pcIconlist).
  DO i = 1 TO iIcons:
    ASSIGN cIconFile = SEARCH(ENTRY(i, pcIconlist)).

    /* --- load each iconfile --- */
    RUN SHGetFileInfoA ( INPUT cIconFile
                        ,INPUT 0
                        ,INPUT GET-POINTER-VALUE(lpSHFileInfo)
                        ,INPUT GET-SIZE(lpSHFileInfo)
                        ,INPUT {&SHGFI_ICON} + {&SHGFI_SMALLICON}
                        ,OUTPUT hIcon 
                        ).

    /*---- store their handles ----*/
    ASSIGN hTrayIcon = GET-LONG(lpSHFileInfo, 1)
           pcIconHandles = pcIconHandles +
                           MIN(pcIconHandles,",":U) +
                           STRING(hTrayIcon).
           .
  END. /* DO */

  /* --- free lpSHFileInfo structure --- */
  SET-SIZE(lpSHFileInfo) = 0.
    

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ip-next-icon Include 
PROCEDURE ip-next-icon :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  RUN ip-notify-icon(fn-get-next-icon(), {&NIM_MODIFY}).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ip-RestoreWindow Include
PROCEDURE ip-RestoreWindow :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  define input parameter hw as handle no-undo.

     ASSIGN hw:VISIBLE      = TRUE
            hw:WINDOW-STATE = WINDOW-NORMAL.
     RUN SetActiveWindow (fnGetParent(hw:HWND)).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ip-show-icon Include
PROCEDURE ip-show-icon :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  define input parameter nr       as integer   no-undo.
  define input parameter pTooltip as character no-undo.

  IF nr>0 and nr<=iICons then
     iCurrentIcon = nr.

  cTooltip = pTooltip + chr(0).
  RUN ip-notify-icon(INTEGER(ENTRY(iCurrentIcon, cIconHandles)), {&NIM_MODIFY}).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ip-notify-icon Include 
PROCEDURE ip-notify-icon :
/*------------------------------------------------------------------------------
  Purpose:     the core procedure for add,modifying,deleting systray icons
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER phTrayIcon AS INTEGER NO-UNDO.
DEFINE INPUT PARAMETER phAction   AS INTEGER NO-UNDO.

DEFINE VARIABLE iRetVal      AS INTEGER NO-UNDO.
DEFINE VARIABLE hWndParent   AS INTEGER NO-UNDO.


hWndParent = fnGetParent({&WINDOW-NAME}:hWnd).

/* --- construct pNotifyIconData structure --- */
IF GET-SIZE(pNotifyIconData) = 0   /* --- alloc memory once --- */
THEN DO:
  SET-SIZE(pNotifyIconData) = {&SIZEOF_pNotifyIconData}.
  phAction = {&NIM_ADD}.      /* first time, so it must be an add */
END. /* IF */  

/*--- build Icondata structure, this will last until proc ends ---*/
PUT-LONG(pNotifyIconData,1)    = {&SIZEOF_pNotifyIconData}.  
PUT-LONG(pNotifyIconData,5)    = hWndParent.
PUT-LONG(pNotifyIconData,9)    = iTrayID. 
PUT-LONG(pNotifyIconData,13)   = {&NIF_ICON} + {&NIF_TIP} + {&NIF_MESSAGE}.
PUT-LONG(pNotifyIconData,17)   = {&WM_LBUTTONDOWN}.
PUT-LONG(pNotifyIconData,21)   = phTrayIcon.
PUT-STRING(pNotifyIconData,25) = SUBSTRING(cToolTip,1,63). /* max 64 char including #0 */
PUT-BYTE(pNotifyIconData,88)   = 0.   /* cTooltip must include #0 */
  
RUN  Shell_NotifyIconA (INPUT phAction
                       ,INPUT GET-POINTER-VALUE(pNotifyIconData)
                       ,OUTPUT iRetVal
                       ).


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ip-systray-exit Include 
PROCEDURE ip-systray-exit :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  /*--- remove icon from systray ---*/  
  RUN ip-notify-icon(fn-get-next-icon(), {&NIM_DELETE}).
  
  
  /* --- free icondata structure --- */
  SET-SIZE(pNotifyIconData) = 0.  

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ip-systray-init Include 
PROCEDURE ip-systray-init :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER piTrayID   AS INTEGER NO-UNDO.  
  DEFINE INPUT PARAMETER pcIconList AS CHARACTER NO-UNDO.
  DEFINE INPUT PARAMETER pcTooltip  AS CHARACTER NO-UNDO.

  DEFINE VARIABLE hparent AS INTEGER NO-UNDO.
  DEFINE VARIABLE hc      AS COM-HANDLE NO-UNDO.

  &IF "{&WINDOW-NAME}" <> "" &THEN
     /* if this is a window: */
     hparent = fnGetParent({&WINDOW-NAME}:hwnd).
  &ELSE
     /* if this is a dialog: */
     hParent = frame {&FRAME-NAME}:hwnd.
  &ENDIF
  
  ASSIGN iTrayID   = piTrayID
         cTooltip  = pcTooltip.
  
  hc = chCtrlFrame:Msgblst32.
  hc:MsgList(0) = {&WM_LBUTTONDOWN}.   
  hc:MsgPassage(0) = 1. 
  hc:hWndTarget = hparent.
  RELEASE OBJECT hc.

  /* attach our Frame popup to the Msgblaster controlframe. 
     this way we get a popup-menu on rightclick of the systray icon.
     we need the msgblst ocx to catch the mouse messages.
     see the message trigger of the MsgBlst ocx.  */

  DO WITH FRAME {&FRAME-NAME}:
    ASSIGN  FRAME {&FRAME-NAME}:POPUP-MENU = ?
            CtrlFrame:POPUP-MENU = MENU systray-popup:HANDLE.
  END.

  /* --- make sure tooltip-string is null terminated --- */
  cToolTip = cToolTip + chr(0).

  RUN ip-load-icons(INPUT pcIconlist, INPUT-OUTPUT cIconHandles).


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fn-get-next-icon Include 
FUNCTION fn-get-next-icon RETURNS INTEGER
  (  ) :
/*------------------------------------------------------------------------------
  Purpose:  animate through iconlist
    Notes:  
------------------------------------------------------------------------------*/

  IF iCurrentIcon < iIcons
  THEN ASSIGN iCurrentIcon = iCurrentIcon + 1.
  ELSE ASSIGN iCurrentIcon = 1.
     
  RETURN INTEGER(ENTRY(iCurrentIcon, cIconHandles)).

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

