/* ====================================================================
   file    : proed4w/setup/addprotools.p
   by      : Jurjen
   purpose : Add wined4w to protools.dat
   ==================================================================== */
   
DEFINE VARIABLE ProtoolsDatfile  AS CHARACTER NO-UNDO.
DEFINE VARIABLE cProgram         AS CHARACTER NO-UNDO.
DEFINE VARIABLE iOrder           AS INTEGER   NO-UNDO.
DEFINE VARIABLE iMaxOrder        AS INTEGER   NO-UNDO.
DEFINE VARIABLE lAlreadyInThere  AS LOGICAL   NO-UNDO INITIAL NO.

GET-KEY-VALUE SECTION "ProTools"
    KEY "FunctionDefs" VALUE ProtoolsDatfile.
IF ProtoolsDatfile=? THEN RETURN.

/* read protools.dat */
INPUT FROM VALUE(ProtoolsDatfile).
REPEAT:
    ASSIGN cProgram = ""
           iOrder   = 0.
    IMPORT ^ cProgram ^ ^ ^ iOrder ^.
    IF cProgram MATCHES "*wined4w.w" THEN
        lAlreadyInThere = TRUE.
    IF iOrder > iMaxOrder THEN
       iMaxOrder = iOrder.
END.
INPUT CLOSE.

/* append to protools.dat, if still needed */
IF NOT lAlreadyInThere THEN DO:
   OUTPUT TO VALUE(ProtoolsDatfile) APPEND.
   PUT UNFORMATTED 
       SUBSTITUTE('"Ed4Win server" "proed4w/wined4w.w" "proed4w/protools.bmp" yes yes &1 no',STRING(iMaxOrder + 10))
       SKIP.
   OUTPUT CLOSE.
END.

